﻿

import matplotlib.pyplot as plt
import numpy as np
import sys
import read_data as baza


opcje_proj = baza.Opcje_projektu()
opcje_subst = baza.Opcje_substancji()

baza.odczyt_substan()
opcje_proj.odczyt()
conproj = baza.con_opc

if __debug__:

    print ("\nLiczba substancji w bazie danych: ", len(baza.substancje))
    print ("liczba obliczanych:",len(opcje_proj.obliczane))
    print ("nazwy obliczanych substancji:")
    print (" nr kolejny \t Nr na liście  \t Nazwa")
    print ("=========================================================")

    nrb =1
    for b in opcje_proj.obliczane:
        i = b[0]-1  # numer na ogolnej liscie
        if i< len(baza.substancje):
            print (" {0:8}  {1:10}            {2:20}".format(nrb,b[0],baza.substancje[i].nazwa))
            nrb +=1

siatka = opcje_proj.siatka

if __debug__:
    print("siatka regularna ", siatka.regularna)
    f = siatka
    print ("siatka x0,dx,xk,y0,dy,yk ",f.xp,f.dx,f.xk,f.yp,f.dy,f.yk )
    print ("liczba punktów ", siatka.ile_punktow)

#zalozenia do testu
idx_zan= 0 #kolejny numer obliczanej substancji od zera
nr_zan = opcje_proj.obliczane[0][idx_zan]

#print ("nr zan", nr_zan) Ok.

rodzaj = 1 #srednie
opcje_subst.odczyt(conproj,nr_zan,rodzaj)

if __debug__:
    print ("opcje zanieczyszczenia, tytul:", opcje_subst.tytul1)

baza.odczyt_wynikow_stez_regul(conproj, nr_zan, rodzaj, siatka) #0=max 1=srednie   26=ksylen, 200=pyl
#print ("Odczytano wyniki")

nx=siatka.szer()
ny=siatka.wys()

print ("nx,ny", nx,ny)
print ("len wyniki[0] ", len(baza.wyniki[0]))  #=ny
print("wyniki dla pocz. punktu ", baza.wyniki[0][0], " koncowego  ", baza.wyniki[ny - 1][nx - 1])

#https://matplotlib.org/3.1.1/gallery/images_contours_and_fields/contour_demo.html#sphx-glr-gallery-images-contours-and-fields-contour-demo-py

feature_x = np.linspace(siatka.xp, siatka.xk, nx,  endpoint=True)
feature_y = np.linspace(siatka.yp, siatka.yk, ny,  endpoint=True)

print('len(x) ',len(feature_x)) #nx
print('len(y) ',len(feature_y)) #ny

# Creating 2-D grid of features
[X, Y] = np.meshgrid(feature_x, feature_y)
fig, ax = plt.subplots()

#odwroc
#Z= [[0] * nx for i in range(ny)]
#for ix in range(0,nx):
#   for iy in range(0,ny):
#       Z[iy][ix]=baza.wyniki[ix][iy]

Z = baza.wyniki

lmax= np.amax(baza.wyniki)
print ("max wyniki= ",lmax)
print ("max Z= ",np.amax(Z))

if not lmax:
  sys.exit('brak danych do wykreślenia izolinii')

lmin = baza.round_sig(lmax/100)
lmax = baza.round_sig(lmax)
lstep = baza.round_sig(lmax/10)

if opcje_subst.ile_poziomow:
    levels =opcje_subst.poziomy
else:
    levels = np.arange(lmin,lmax,lstep)
    print('poziomy ustalono z min, max', lmin, lmax)


#wykres= ax.contour(X, Y, Z, levels)

wykres= ax.contour(X, Y, Z, levels,   colors=( 'green', 'blue','cyan','magenta','red'))

ax.set_title(opcje_subst.tytul1)
ax.set_xlabel('X')
ax.set_ylabel('Y')

plt.clabel(wykres, levels, inline=True, fontsize=10)  #https://matplotlib.org/3.1.1/api/_as_gen/matplotlib.pyplot.clabel.html

#ozdobki

plt.show()
